// brb: Accessibility fix - change 'query' spans to divs
$('span[data-type="query"]').each(function () {
  $(this).changeElementType('div');
});


$('body').append('<div id="text_resize" style="color: transparent" aria-hidden="true">X</div>');

function calculateFigureIframeHeight($iframe, id) {

  //console.log('calculateFigureIframeHeight: ', $iframe);

  if (id === 'body') {
    return $iframe.contents().height();
  }

  return $iframe.contents().find('#' + id).height();
}

function mainHandleTextResize(event, args) {
  //console.log('caught text resize event');
  resizeResultsIframe();

  if (typeof localHandleTextResize === 'function') {
    localHandleTextResize();
  }

  try {
    parent.PX.API.Content.ResetHeight()
  }
  catch (e) {

  }
}

function resizeResultsIframe() {
  //console.log('resizeResultsIframe()');
  var $iframe = $('#results_iframe');

  if ($iframe.length < 1) {
    return;
  }

  var iframeContentHeight = calculateFigureIframeHeight($iframe, 'results_wrapper');

  //console.log('results iframe height = ' + iframeContentHeight);

  if (iframeContentHeight > 0) {
    //console.log('resizeIframe: setting iframe height to ' + iframeContentHeight);
    //$iframeDiv.css('height', iframeContentHeight + 'px');
    $iframe.attr('height', iframeContentHeight);
  }
}

function initTextResize() {
  TextResizeDetector.addEventListener(mainHandleTextResize, null);
}

//id of element to check for and insert control
TextResizeDetector.TARGET_ELEMENT_ID = 'text_resize';
//function to call once TextResizeDetector has init'd
TextResizeDetector.USER_INIT_FUNC = initTextResize;


webpackJsonp([0], {

/***/ 18:
/***/ (function(module, exports, __webpack_require__) {

"use strict";


__webpack_require__(5);

var ConcretePlayer = __webpack_require__(1);
window.player = new ConcretePlayer();
window.player.experiment_section = 2;

MC_Query = __webpack_require__(35);
  Figures = Figures.extend( {
    notify_iframes: function ( jq ) {
      if ( jq == null ) {
        jq = $( 'body' );
      }

      if (jq.find('[data-block_type="video"]').length === 0) {
        jq.find( 'iframe' ).each( function ( i, iframe ) {
          if ( typeof iframe.contentWindow.isBecomingVisible === 'function' ) {
            iframe.contentWindow.isBecomingVisible();
          }
        });
      }
      else {
        jq.find( 'iframe:not([data-block_type="video"] iframe)' ).each( function ( i, iframe ) {
          if ( typeof iframe.contentWindow.isBecomingVisible === 'function' ) {
            iframe.contentWindow.isBecomingVisible();
          }
        });
      }
    },
    init: function () {
      this.process_swfs(); // flash
      this.process_media(); // mp3s and other things that get played via the MediaPlayer

      // only load all iframes at once if player.md.preload_all_iframes is set to true
      // otherwise we do it as we load each section.
      if (player.md.not_preload_all_iframes !== 'true') {
        this.process_iframes();// iframes
      }

      if ( player.md.not_include_common_styles !== 'true' ) {
        $('iframe').load( function () {
          safe_log('adding common.css to iframe');
          $('iframe').contents().find('head')
            .append($('<link href=\''+
            '../common.css\'' +
            'media=\'screen\' rel=\'stylesheet\' type=\'text/css\' >'));
            $('iframe').contents().find('head')
            .append($('<link href=\''+
            '../../common.css\'' +
            'media=\'screen\' rel=\'stylesheet\' type=\'text/css\' >'));
          
        });
      }

      // Figure references in the text should pop up the figure, unless the figure isn't expandable
      $('[data-type=\'ref\'][data-ui=\'figure\']').each(function (index, element) {
        // get the figure's jquery object to determine if it's expandable
        var fig_id = $(element).attr('data-refid');
        var fig_jq = $('[data-figure-id=' + fig_id + ']');

        // currently we can only expand images; this should change later
        var is_image = (fig_jq.find('[data-mmtype=image]').length > 0);
        if (fig_jq.attr('expandable') != 'false' && is_image) {
          $(element).click(function () {
 return player.figures.expand($(this).attr('data-refid'));
}).css('cursor', 'pointer');
        }
      });

      // Now the figures themselves
      $('[data-type=\'figure\']').each(function (index, element) {
        var jq = $(element);
        var ijq = $('[data-mmtype]', jq); // the figure's main image will have a mmtype tag
        // get the figure id

        // if the figure is expandable, make the figure and its number clickable
        // currently we can only expand images; this should change later
        if (jq.attr('data-expandable') != 'false' && ijq.attr('data-mmtype') == 'image') {
          ijq.click(function () {
 return player.figures.expand(this);
}).css('cursor', 'pointer');
          $('[data-type=\'number\']', jq).click(function () {
 return player.figures.expand(this);
}).css('cursor', 'pointer');

          // also, if altsrc isn't specified, set it to the image source
          if (jq.attr('data-altsrc') == undefined) {
            jq.attr('data-altsrc', ijq.attr('src'));
          }
        }

        // deal with attributes field on the image
        // note that multiple attributes must be separated by " | " -- at least one space
        // surrounding each attribute. This allows "||" to be a valid part of an attribute
        var attr = ijq.attr('data-attr');
        if (attr != null) {
          attr = attr.split(/\s* \| \s*/);
          for (var i = 0; i < attr.length; ++i) {
            if (attr[i].search(/^(\w+)=(.*)/) > -1) {
              var key = RegExp.$1;
              var value = RegExp.$2;

              if (key == 'onclick') {
                ijq.click(new Function(value));
                ijq.css('cursor', 'pointer');

                // default: just write them out as attributes of the image
              }
 else {
                ijq.attr(key, value);
                //safe_log('Image attribute: set ' + key + ' to ' + value);
              }
            }
 else if (attr[i] != '') {
              safe_log('Bad image attribute (' + i + '): \'' + attr[i] + '\'');
            }
          }
        }
      });
    }
  } );

  window.Standard_Dialog.close = function () {

        //safe_log("Standard_Dialog.close");

        $( '#standard_dialog_div' ).remove();

        //safe_log(this.jq);
        this.jq && this.jq[0].focus();
  };
      
  window.Standard_Dialog.open = function (html, options, jq) {

    //console.log('Standard_Dialog.open()');

    this.jq = jq;
    var dialog;
    if (options == null) options = {};
    if (options.width == 'auto') options.width = null;
    else if (options.width == null) options.width = 450;
    if (options.modal == null) options.modal = true;
    if (options.draggable == null) options.draggable = false;
    if (options.resizable == null) options.resizable = false;
    if (options.buttons == 'none') options.buttons = null;
    else if (options.buttons == 'OK' || options.buttons == null) {
      options.buttons = [{
        text: 'OK', click: Standard_Dialog.close.bind(this)
      }];
    }
    options.close = function () {
      this.jq && this.jq[0].focus();
    }.bind(this);
    options.create=function (e, ui) {
      var $dialog = dialog.dialog('widget');

      var $header = $dialog.find('.ui-dialog-title');
      $header.attr({'tabindex': 0, 'role': 'alert'});

      var $closeBttn = $dialog.find('.ui-dialog-titlebar-close');
      $dialog.append( $closeBttn );
      $dialog.append( '<span tabindex="0">' );
      $closeBttn.blur(function (e) {
        e.preventDefault();
        e.stopPropagation();
        $header[0].focus();
      });

      setTimeout(function () {
        $header[0].focus();
      }, 10);
    };
    $('#standard_dialog_div').dialog('close');
    $('#standard_dialog_div').remove();

    html = '<div id=\'standard_dialog_div\' tabindex=\'0\'>' + html + '</div>';
    $('body').append(html);

    dialog = $('#standard_dialog_div');
    dialog.dialog(options);
  };


/***/ }),

/***/ 35:
/***/ (function(module, exports, __webpack_require__) {

var subtype_mc = __webpack_require__(38);
var platform = __webpack_require__(0).run_on;

var project_mc = subtype_mc.extend( {

  // brb: override so we can clean the query text sent to the grade book
  getQueryTextForARGA: function() {

    //safe_log("getQueryTextForARGA");
    if (this.query_text_for_ARGA != null && this.query_text_for_ARGA != "") {
      //safe_log("returning query_text_for_ARGA");
      return this.query_text_for_ARGA;
    }
    else if (this.query_text != null && this.query_text != "") {
      //safe_log("query_text: " + this.query_text);
      var cleaned_text = player.clean_query_text(this.query_text);
      //safe_log("cleaned text: " + cleaned_text);
      return cleaned_text;
    }
    else {
      return "see page for question context";
    }
  },

    query_text_html: function () {
      var query_text = this._super();
      var first = query_text.indexOf('>') + 1;
      //this.jq.parent().find('h3').remove();
      return query_text.substring(0, first) + this.parent_question.number + ' ' + query_text.substring(first);
    },
    // Mode should be "delivery" or "review"; "delivery" is assumed
  getHTML: function (mode) {
      

    //console.log('project_mc.getHTML(' + mode + ')');

    // initialize imagemap elements
    var html = this._super(mode);

    //console.log('project_mc.getHTML: ', html);


      var alphabet = ['A. ', 'B. ', 'C. ', 'D. ', 'E. '];
      var $firstChild = $($(html).children()[0]);
      $firstChild.find('label').each(function () {
        this.innerHTML = (alphabet[this.id[this.id.length - 1]] + this.innerHTML);
        this.setAttribute('aria-hidden', 'true');
      });
      if (!this.user_answer_index && this.user_answer_index !== 0) {
        $firstChild.find('span.query_correct_feedback_span').replaceWith('');
        $firstChild.find('span.query_incorrect_feedback_span').replaceWith('');
      }
      else {
        $firstChild.find('span.query_correct_feedback_span').replaceWith('<div class="correct_feedback"/>');
        $firstChild.find('span.query_incorrect_feedback_span').replaceWith('<div class="incorrect_feedback"/>');
      }
      var $newHTML = $(html).children();

      var $underline = $(html).children().find('[data-block_type="underline"]');
      $underline.each(function () {
        var $this = $(this);
        $this.attr('aria-hidden', 'true').attr('tabindex', '-1');
        $('<span class="visually-hidden"> ,blank, </span>').insertBefore($this);
        $this.replaceWith($('<span style="width: 40px; border-bottom: 1px solid; display: inline-block;"></span>'));
      });
    
      if (platform.ie || platform.firefox) {
        if (mode === 'review') {
          $newHTML.find('label').each(function () {
            var $label = $(this);
            var $input = $newHTML.find('#' + $label.attr('for'));
            $input.removeAttr('aria-hidden').removeAttr('aria-labelledby');
            $label.removeAttr('aria-hidden').removeAttr('tabIndex');
          });
        }
      }
      if (platform.mac) {
        $newHTML.html($newHTML.html().replace('legend', 'div').replace('/legend', '/div'));
        $newHTML.find('.query_text').attr('id', 'query_text_' + this.parent_question.index);
        var $firstRadio = $($newHTML.find('input[type="radio"]')[0]);
        $firstRadio.attr('aria-labelledby', 'query_text_' + this.parent_question.index
          + ' ' + $firstRadio.attr('aria-labelledby'));
      }
      return html;
    }
  } );

  module.exports = project_mc;


/***/ }),

/***/ 37:
/***/ (function(module, exports, __webpack_require__) {

"use strict";


var UtilsShuffle = {};

UtilsShuffle.currentQuestionIsRandomize = function() {
  return Boolean(player.activity.question_being_initialized.md["randomize-choices"]);
};

UtilsShuffle.getFilledArr = function(maxValue) {
  var arr = [];

  for (var i = 0; i < maxValue; i++) {
    arr[i] = i;
  }
  arr.shuffle();

  return arr;
};

UtilsShuffle.shuffleArrays = function() {
  var arrs = [];
  var length = arguments[0].length;
  var shuffleArr = UtilsShuffle.getFilledArr(length);
  var lengthArguments = arguments.length;
  var callBackFunctions = null;

  if (typeof arguments[lengthArguments - 1] === 'function') {
    lengthArguments--;
    callBackFunctions = arguments[lengthArguments];
  }

  // create new example of arrays
  for (var i = 0; i < lengthArguments; i++) {
    arrs[i] = [];
  }

  // shuffle of this arrays
  for (var index = 0; index < length; index++) {
    var el = shuffleArr[index];

    for (var countArrFirst = 0; countArrFirst < lengthArguments; countArrFirst++) {
      arrs[countArrFirst].push(arguments[countArrFirst][el]);
    }
  }

  // return this arrays example
  if (callBackFunctions) {
    callBackFunctions.apply(null, arrs);
  }
  else {
    for (var countArrSecond = 0; countArrSecond < lengthArguments; countArrSecond++) {
      arguments[countArrSecond] = arrs[countArrSecond];
    }
  }

  // return array of shuffle index
  return shuffleArr;
};

module.exports = UtilsShuffle;

/***/ }),

/***/ 38:
/***/ (function(module, exports, __webpack_require__) {

"use strict";


var common = __webpack_require__( 4 );
var dom = __webpack_require__( 2 );
var UtilsShuffle = __webpack_require__( 37 );
var platform = __webpack_require__(0).run_on;

var Query = MC_Query.extend( {

  // brb: override so we can clean the query text sent to the grade book
  getQueryTextForARGA: function() {

    //safe_log("getQueryTextForARGA");
    if (this.query_text_for_ARGA != null && this.query_text_for_ARGA != "") {
      //safe_log("returning query_text_for_ARGA");
      return this.query_text_for_ARGA;
    }
    else if (this.query_text != null && this.query_text != "") {
      //safe_log("query_text: " + this.query_text);
      var cleaned_text = player.clean_query_text(this.query_text);
      //safe_log("cleaned text: " + cleaned_text);
      return cleaned_text;
    }
    else {
      return "see page for question context";
    }
  },

  parseSource: function() {
    this._super.apply( this, arguments );
    if ( UtilsShuffle.currentQuestionIsRandomize() ) {
      var shuffleArr = UtilsShuffle.shuffleArrays( this.choices, this.choices_fb, function( choices, choices_fb ) {
        this.choices = choices;
        this.choices_fb = choices_fb;
      }.bind( this ) );

      this.correct_answer_index = shuffleArr.indexOf( this.correct_answer_index );
    }
  },

  /**
   * Get correct HTML for query text and set id for following use
   * @returns {string} Html for query text
   */
  query_text_html: function() {
    if ( this.query_text != '' && this.md._hide_query_text !== 'true' ) {
      // Replace newlines with <br />
      var text = jQuery.trim( this.query_text ).replace( /\n/g, '<br>' );

      // Set id for use it to associate query text with input radios
      if ( platform.ios ) {
        // iOS doesn't see legend
        return '<div class="query_text">' + text + '</div>';
      }
      else {
        //console.log(text);
        return '<legend class="query_text">' + text + '</legend>';
      }
    }
    else {
      return '';
    }
  },
  getHTML: function( mode ) {
    // Initialize image map elements
    if ( this.imagemap_initialized === false ) {
      var question_jq = this.jq.parent();
      this.im_init( question_jq );
      this.imagemap_initialized = true;
    }

    //safe_log("MC_Query.getHTML(" + mode + ")");

    // Wrap answers in radio group
    var html = '<fieldset class="mc_query_group">';

    // Add the query 
    var query_txt_html = this.query_text_html();

    var fitb = '';
    if (/type="underline"/.test(query_txt_html)) {
      fitb = "Fill in the blank, ";
    }

    query_txt_html = query_txt_html.replace(/(<legend [^>]+>)(\d+)\./, "$1<span class='visually-hidden'>Question $2, " + fitb + "</span>");

    //console.log('getHTML: query_txt_html = ' + query_txt_html);

    html += query_txt_html;

    for ( var i = 0; i < this.choices.length; i++ ) {
      var index = this.choice_order[ i ];

      // If this is review mode
      var checked = '';
      var disabled = '';
      var className = '';
      var mark = '';

      if ( mode === 'review' || mode === 'review_correct_incorrect' || mode === 'preview' ) {
        // If it is correct answer
        if ( index === this.correct_answer_index ) {
          // Mark it in green
          if ( mode !== 'review_correct_incorrect' || index === this.user_answer_index ) {
            className = 'mc_correct_choice';
            html += '<span class="query_correct_feedback_span" aria-hidden="true">&nbsp;</span>';
            mark = '<span class="visually-hidden">Correct</span>';
          }

          // Mark it in red
        } else if ( index === this.user_answer_index && this.md.no_correct_answer !== 'true' ) {
          className = 'mc_incorrect_choice';
          html += '<span class="query_incorrect_feedback_span" aria-hidden="true">&nbsp;</span>';
          mark = '<span class="visually-hidden">Incorrect</span>';
        }

        // And the input should be disabled, unless we're in review_correct_incorrect mode
        disabled = (mode !== 'review_correct_incorrect') ? 'disabled' : '';
      }

      // If this is the choice the user clicked, it's checked (regardless of mode)
      checked = (index === this.user_answer_index) ? 'checked' : '';

      var id = 'query_answer_' + this.query_index + '_' + index;
      var labelId = 'query_answer_label_' + this.query_index + '_' + index;

      // Hide label to avoid twice reading, but not for FF, otherwise FF doesn't read
      var labelHidden = platform.mobile ? 'aria-hidden="true"' : '';

      html +=
        '<input class="query_mc_choice_radio ' + className + '" type="radio" name="query_answer_' + this.query_index + '" id="' + id + '" ' +
        ' value="' + index + '" ' + checked + ' ' + disabled + ' aria-labelledby="' + labelId + '"/>' +
        '<label ' + labelHidden + ' id="' + labelId + '" for="' + id + '">' + this.choices[ index ] + ' ' + mark + '</label><br>';
    }

    // Get a possible feedback string for each option
    html += this.correct_incorrect_feedback();

    html += "</fieldset>";

    //safe_log('MC_Query.getHTML: ' + html);

    html = dom.createHTML( html );
    common.parseMathExpresions( html );

    return html;
  },
  /**
   * If we have individual feedback for each mc option
   * @returns {string} Html for the feedback
   */
  correct_incorrect_feedback: function() {

    // Try get individual feedback for option
    var index = this.choice_order[this.user_answer_index]; // Get correct index, if choices are scrambled
    var html = this.choices_fb[index] || '';

    //safe_log("correct_incorrect_feedback()");

    // If we got any feedback, enclose it in a div
    if (html) {
      //safe_log("[" + html +"]");
      html = '<div class="query_mc_feedback_correct_incorrect">' + html + '</div>';
    }

    return html;
  }
} );

module.exports = Query;


/***/ }),

/***/ 51:
/***/ (function(module, exports, __webpack_require__) {

module.exports = __webpack_require__(18);


/***/ })

},[51]);
//# sourceMappingURL=science_of_everyday_life_upd.js.map

// brb: Adding this so we can fix add_from_jq to use 'data-key' attribute
// instead of just 'key' which the HTML validator does not like.
Metadata = Metadata.extend({

  add_from_jq: function (jq) {
    if (jq == null || jq.length == 0) {
      return;
    }

    // copy out the html so we can paste it back in at the end
    var original_html = jq.html();

    // first extract <field> key-value pairs
    var md = this;
    jq.find("[data-type=field]").each(function (index, element) {
      // brb: accessibility fix
      var key = $(element).attr("data-key");
      var value = $(element).html();
      md.add(key, value);
    });

    // then remove these
    jq.find("[data-type=field]").remove();

    // and look for "old-style" lines (_key: value)
    var lines = jq.html().split("\n");
    for (var i = 0; i < lines.length; ++i) {
      var l = $.trim(lines[i]).replace(/^_/, "");
      if (l == "") continue;

      if (l.search(/^(.*?)\s*:\s*(.*)/) > -1) {
        md.add(RegExp.$1, RegExp.$2);
      } else {
        safe_log("bad metadata line: " + l);
      }
    }

    // now restore the original html
    jq.html(original_html);
  },

});

Figures = Figures.extend({

  process_iframes: function (jq) {

    //safe_log('Figures.process_iframes');

    if (jq == null) {
      jq = $("body");
    }

    jq.find("[data-mmtype='iframe']").each(function (index, element) {
      var jq = $(element);

      //console.log('process_iframes...');
      //console.log(jq);

      //var id = jq.attr("data-figure-id");
      var src = jq.attr("data-mmsrc");
      var attr = jq.attr("data-attr");
      var title = jq.attr('data-title');

      if (title === undefined) {
        title = jq.parent('div').attr('data-title');
      }

      if (title === undefined) {
        title = "Results";
      }
      if (attr == null) {
        attr = [];
      }
      else {
        attr = attr.split(/\s*,\s*/);
      }

      var iframeid = jq.parent('div').attr('data-iframeid');

      // get default width and height from the placeholder image
      var params = new Object();
      // brb: Don't set width/height so we can make the ifraem responsive.
      params.width = jq.width();
      params.height = jq.height();
      //params.frameborder = "no";
      //params.scrolling = "no";
      //params.style = "margin:0px; padding:0px";
      params.src = src;
      params.title = title;
      //params.class = 'resp-iframe';

      if (iframeid !== undefined && iframeid !== '') {
        params.id = iframeid;
      }


      //console.log('attr = ', attr);
      for (var i = 0; i < attr.length; ++i) {
        var a = attr[i].split(/\s*=\s*/);
        params[a[0]] = a[1];
      }
      //console.log('params = ', params);

      var pstring = "";
      for (var i in params) {
        pstring += ' ' + i + '="' + params[i] + '"';
      }

      //console.log('pstring = ', pstring);

      //jq.parent().addClass('resp-container');

      jq.replaceWith('<iframe ' + pstring + '></iframe>');

    });
  },

});

// brb: Accessibility fix - Prevent HTML validator from throwing error for this
(function () {
  $('meta[http-equiv="X-UA-Compatible"]').each(function () {
    $(this).attr('content', 'IE=edge');
  });
})();